#region Ressources extérieures
using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Projet_GestionCommerceInfo.Classes;
#endregion

namespace Projet_GestionCommerceInfo.Acces
{
 /// <summary>
 /// Couche d'accès aux données (Data Access Layer)
 /// </summary>
 public class A_Panier : ADBase
 {
  #region Constructeurs
  public A_Panier(string sChaineConnexion)
  	: base(sChaineConnexion)
  { }
  #endregion
  public int Ajouter(int UserId, string Nom, int? Status, DateTime? DateAchat, int Type)
  {
   CreerCommande("AjouterPanier");
   int res = 0;
   Commande.Parameters.Add("ID", SqlDbType.Int);
   Direction("ID", ParameterDirection.Output);
   Commande.Parameters.AddWithValue("@UserId", UserId);
   if(Nom == null) Commande.Parameters.AddWithValue("@Nom", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@Nom", Nom);
   if(Status == null) Commande.Parameters.AddWithValue("@Status", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@Status", Status);
   if(DateAchat == null) Commande.Parameters.AddWithValue("@DateAchat", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@DateAchat", DateAchat);
   Commande.Parameters.AddWithValue("@Type", Type);
   Commande.Connection.Open();
   Commande.ExecuteNonQuery();
   res = int.Parse(LireParametre("ID"));
   Commande.Connection.Close();
   return res;
  }
  public int Modifier(int ID, int UserId, string Nom, int? Status, DateTime? DateAchat, int Type)
  {
   CreerCommande("ModifierPanier");
   int res = 0;
   Commande.Parameters.AddWithValue("@ID", ID);
   Commande.Parameters.AddWithValue("@UserId", UserId);
   if(Nom == null) Commande.Parameters.AddWithValue("@Nom", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@Nom", Nom);
   if(Status == null) Commande.Parameters.AddWithValue("@Status", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@Status", Status);
   if(DateAchat == null) Commande.Parameters.AddWithValue("@DateAchat", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@DateAchat", DateAchat);
   Commande.Parameters.AddWithValue("@Type", Type);
   Commande.Connection.Open();
   Commande.ExecuteNonQuery();
   Commande.Connection.Close();
   return res;
  }
  public List<C_Panier> Lire(string Index)
  {
   CreerCommande("SelectionnerPanier");
   Commande.Parameters.AddWithValue("@Index", Index);
   Commande.Connection.Open();
   SqlDataReader dr = Commande.ExecuteReader();
   List<C_Panier> res = new List<C_Panier>();
   while (dr.Read())
   {
    C_Panier tmp = new C_Panier();
    tmp.ID = int.Parse(dr["ID"].ToString());
    tmp.UserId = int.Parse(dr["UserId"].ToString());
    tmp.Nom = dr["Nom"].ToString();
   if(dr["Status"] != DBNull.Value) tmp.Status = int.Parse(dr["Status"].ToString());
   if(dr["DateAchat"] != DBNull.Value) tmp.DateAchat = DateTime.Parse(dr["DateAchat"].ToString());
    tmp.Type = int.Parse(dr["Type"].ToString());
    res.Add(tmp);
			}
			dr.Close();
			Commande.Connection.Close();
			return res;
		}
  public C_Panier Lire_ID(int ID)
  {
   CreerCommande("SelectionnerPanier_ID");
   Commande.Parameters.AddWithValue("@ID", ID);
   Commande.Connection.Open();
   SqlDataReader dr = Commande.ExecuteReader();
   C_Panier res = new C_Panier();
   while (dr.Read())
   {
    res.ID = int.Parse(dr["ID"].ToString());
    res.UserId = int.Parse(dr["UserId"].ToString());
    res.Nom = dr["Nom"].ToString();
   if(dr["Status"] != DBNull.Value) res.Status = int.Parse(dr["Status"].ToString());
   if(dr["DateAchat"] != DBNull.Value) res.DateAchat = DateTime.Parse(dr["DateAchat"].ToString());
    res.Type = int.Parse(dr["Type"].ToString());
   }
			dr.Close();
			Commande.Connection.Close();
			return res;
		}
  public int Supprimer(int ID)
  {
   CreerCommande("SupprimerPanier");
   int res = 0;
   Commande.Parameters.AddWithValue("@ID", ID);
   Commande.Connection.Open();
   res = Commande.ExecuteNonQuery();
			Commande.Connection.Close();
			return res;
		}
 }
}
