#region Ressources extérieures
using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Projet_GestionCommerceInfo.Classes;
#endregion

namespace Projet_GestionCommerceInfo.Acces
{
 /// <summary>
 /// Couche d'accès aux données (Data Access Layer)
 /// </summary>
 public class A_Utilisateur : ADBase
 {
  #region Constructeurs
  public A_Utilisateur(string sChaineConnexion)
  	: base(sChaineConnexion)
  { }
  #endregion
  public int Ajouter(string Nom, string Prenom, string Adresse, string NCompte, DateTime? DateDeNaisance, int type, bool Actif, string email)
  {
   CreerCommande("AjouterUtilisateur");
   int res = 0;
   Commande.Parameters.Add("ID", SqlDbType.Int);
   Direction("ID", ParameterDirection.Output);
   if(Nom == null) Commande.Parameters.AddWithValue("@Nom", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@Nom", Nom);
   if(Prenom == null) Commande.Parameters.AddWithValue("@Prenom", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@Prenom", Prenom);
   if(Adresse == null) Commande.Parameters.AddWithValue("@Adresse", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@Adresse", Adresse);
   if(NCompte == null) Commande.Parameters.AddWithValue("@NCompte", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@NCompte", NCompte);
   if(DateDeNaisance == null) Commande.Parameters.AddWithValue("@DateDeNaisance", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@DateDeNaisance", DateDeNaisance);
   Commande.Parameters.AddWithValue("@type", type);
   Commande.Parameters.AddWithValue("@Actif", Actif);
   Commande.Parameters.AddWithValue("@email", email);
   Commande.Connection.Open();
   Commande.ExecuteNonQuery();
   res = int.Parse(LireParametre("ID"));
   Commande.Connection.Close();
   return res;
  }
  public int Modifier(int ID, string Nom, string Prenom, string Adresse, string NCompte, DateTime? DateDeNaisance, int type, bool Actif, string email)
  {
   CreerCommande("ModifierUtilisateur");
   int res = 0;
   Commande.Parameters.AddWithValue("@ID", ID);
   if(Nom == null) Commande.Parameters.AddWithValue("@Nom", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@Nom", Nom);
   if(Prenom == null) Commande.Parameters.AddWithValue("@Prenom", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@Prenom", Prenom);
   if(Adresse == null) Commande.Parameters.AddWithValue("@Adresse", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@Adresse", Adresse);
   if(NCompte == null) Commande.Parameters.AddWithValue("@NCompte", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@NCompte", NCompte);
   if(DateDeNaisance == null) Commande.Parameters.AddWithValue("@DateDeNaisance", Convert.DBNull);
   else Commande.Parameters.AddWithValue("@DateDeNaisance", DateDeNaisance);
   Commande.Parameters.AddWithValue("@type", type);
   Commande.Parameters.AddWithValue("@Actif", Actif);
   Commande.Parameters.AddWithValue("@email", email);
   Commande.Connection.Open();
   Commande.ExecuteNonQuery();
   Commande.Connection.Close();
   return res;
  }
  public List<C_Utilisateur> Lire(string Index)
  {
   CreerCommande("SelectionnerUtilisateur");
   Commande.Parameters.AddWithValue("@Index", Index);
   Commande.Connection.Open();
   SqlDataReader dr = Commande.ExecuteReader();
   List<C_Utilisateur> res = new List<C_Utilisateur>();
   while (dr.Read())
   {
    C_Utilisateur tmp = new C_Utilisateur();
    tmp.ID = int.Parse(dr["ID"].ToString());
    tmp.Nom = dr["Nom"].ToString();
    tmp.Prenom = dr["Prenom"].ToString();
    tmp.Adresse = dr["Adresse"].ToString();
    tmp.NCompte = dr["NCompte"].ToString();
   if(dr["DateDeNaisance"] != DBNull.Value) tmp.DateDeNaisance = DateTime.Parse(dr["DateDeNaisance"].ToString());
    tmp.type = int.Parse(dr["type"].ToString());
    tmp.Actif = bool.Parse(dr["Actif"].ToString());
    tmp.email = dr["email"].ToString();
    res.Add(tmp);
			}
			dr.Close();
			Commande.Connection.Close();
			return res;
		}
  public C_Utilisateur Lire_ID(int ID)
  {
   CreerCommande("SelectionnerUtilisateur_ID");
   Commande.Parameters.AddWithValue("@ID", ID);
   Commande.Connection.Open();
   SqlDataReader dr = Commande.ExecuteReader();
   C_Utilisateur res = new C_Utilisateur();
   while (dr.Read())
   {
    res.ID = int.Parse(dr["ID"].ToString());
    res.Nom = dr["Nom"].ToString();
    res.Prenom = dr["Prenom"].ToString();
    res.Adresse = dr["Adresse"].ToString();
    res.NCompte = dr["NCompte"].ToString();
   if(dr["DateDeNaisance"] != DBNull.Value) res.DateDeNaisance = DateTime.Parse(dr["DateDeNaisance"].ToString());
    res.type = int.Parse(dr["type"].ToString());
    res.Actif = bool.Parse(dr["Actif"].ToString());
    res.email = dr["email"].ToString();
   }
			dr.Close();
			Commande.Connection.Close();
			return res;
		}
  public int Supprimer(int ID)
  {
   CreerCommande("SupprimerUtilisateur");
   int res = 0;
   Commande.Parameters.AddWithValue("@ID", ID);
   Commande.Connection.Open();
   res = Commande.ExecuteNonQuery();
			Commande.Connection.Close();
			return res;
		}
 }
}
