#region Ressources extérieures
using System;
using System.Collections.Generic;
using System.Text;
using Projet_GestionCommerceInfo.Classes;
using Projet_GestionCommerceInfo.Acces;
#endregion

namespace Projet_GestionCommerceInfo.Gestion
{
 /// <summary>
 /// Couche intermédiaire de gestion (Business Layer)
 /// </summary>
 public class G_LSTArticle : G_Base
 {
  #region Constructeurs
  public G_LSTArticle()
   : base()
  { }
  public G_LSTArticle(string sChaineConnexion)
   : base(sChaineConnexion)
  { }
  #endregion
  public int Ajouter(int PanierID, int ArticleID, int Quantite, decimal? PrixHTVA, int? TVA)
  { return new A_LSTArticle(ChaineConnexion).Ajouter(PanierID, ArticleID, Quantite, PrixHTVA, TVA); }
  public int Modifier(int ID, int PanierID, int ArticleID, int Quantite, decimal? PrixHTVA, int? TVA)
  { return new A_LSTArticle(ChaineConnexion).Modifier(ID, PanierID, ArticleID, Quantite, PrixHTVA, TVA); }
  public List<C_LSTArticle> Lire(string Index)
  { return new A_LSTArticle(ChaineConnexion).Lire(Index); }
  public C_LSTArticle Lire_ID(int ID)
  { return new A_LSTArticle(ChaineConnexion).Lire_ID(ID); }
  public int Supprimer(int ID)
  { return new A_LSTArticle(ChaineConnexion).Supprimer(ID); }
 }
}
