CREATE PROCEDURE AjouterUtilisateur
 @ID int OUTPUT,
 @Nom varchar(50),
 @Prenom varchar(50),
 @Adresse varchar(50),
 @NCompte varchar(50),
 @DateDeNaisance datetime,
 @type int,
 @Actif bit,
 @email varchar(50)
AS
 INSERT INTO Utilisateur(Nom,Prenom,Adresse,NCompte,DateDeNaisance,type,Actif,email)
  VALUES(@Nom,@Prenom,@Adresse,@NCompte,@DateDeNaisance,@type,@Actif,@email)
 SET @ID=@@IDENTITY
RETURN
GO
CREATE PROCEDURE ModifierUtilisateur
 @ID int,
 @Nom varchar(50),
 @Prenom varchar(50),
 @Adresse varchar(50),
 @NCompte varchar(50),
 @DateDeNaisance datetime,
 @type int,
 @Actif bit,
 @email varchar(50)
AS
 IF(@ID IS NULL OR @ID=0)
  RAISERROR('Identifiant requis !',16,1)
 ELSE  UPDATE Utilisateur
        SET Nom=@Nom,Prenom=@Prenom,Adresse=@Adresse,NCompte=@NCompte,DateDeNaisance=@DateDeNaisance,type=@type,Actif=@Actif,email=@email
        WHERE ID=@ID
RETURN
GO
CREATE PROCEDURE SelectionnerUtilisateur
 @Index VARCHAR(10)
AS
 IF(@Index='Nom') SELECT * FROM Utilisateur ORDER BY Nom
 ELSE IF(@Index='Prenom') SELECT * FROM Utilisateur ORDER BY Prenom
 ELSE IF(@Index='Adresse') SELECT * FROM Utilisateur ORDER BY Adresse
 ELSE IF(@Index='NCompte') SELECT * FROM Utilisateur ORDER BY NCompte
 ELSE IF(@Index='DateDeNaisance') SELECT * FROM Utilisateur ORDER BY DateDeNaisance
 ELSE IF(@Index='type') SELECT * FROM Utilisateur ORDER BY type
 ELSE IF(@Index='Actif') SELECT * FROM Utilisateur ORDER BY Actif
 ELSE IF(@Index='email') SELECT * FROM Utilisateur ORDER BY email
 ELSE SELECT * FROM Utilisateur ORDER BY ID
RETURN
GO
CREATE PROCEDURE SelectionnerUtilisateur_ID
 @ID int
AS
 IF(@ID IS NULL)
  RAISERROR('Identifiant requis !',16,1)
 ELSE
  SELECT ID,Nom,Prenom,Adresse,NCompte,DateDeNaisance,type,Actif,email
  FROM Utilisateur
  WHERE @ID=ID
RETURN
GO
CREATE PROCEDURE SupprimerUtilisateur
 @ID int
AS
 IF(@ID IS NULL)
  RAISERROR('Identifiant requis !',16,1)
 ELSE
  DELETE FROM Utilisateur WHERE @ID=ID
RETURN
GO
